unit Main;

{$mode objfpc}{$H+}

{.$DEFINE CLAUDE}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Grids, ShellCtrls, Menus, Buttons, Spin, ActnList, ListViewFilterEdit,
  JvTabBar, JvPageList, JvTabBarXPPainter;

type

  { TMainForm }

  TMainForm = class(TForm)
    actn_HideTab: TAction;
    actn_Exit: TAction;
    actn_DockIn: TAction;
    actn_AddParentTest: TAction;
    actn_AddMultipleTabs: TAction;
    actn_CloseSelectedTab: TAction;
    actn_AddOneTab: TAction;
    ActionList1: TActionList;
    bttnAddTab: TButton;
    bttnCloseTab: TButton;
    bttnAddMultipleTabs: TButton;
    bttnAddParent: TButton;
    bttnDockIn: TButton;
    bttnVisible: TButton;
    cbCloseButton: TCheckBox;
    cbAllowTabMoving: TCheckBox;
    cbTabHotTracking: TCheckBox;
    cmbPainter: TComboBox;
    cmbOrientation: TComboBox;
    JvPageList1: TJvPageList;
    JvTabBar1: TJvTabBar;
    Label1: TLabel;
    Label2: TLabel;
    lblPainter: TLabel;
    lblOrientation: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    mnuTabs: TMenuItem;
    Separator1: TMenuItem;
    pnlBottom: TPanel;
    pnlTabsButtons: TPanel;
    SpeedButton1: TSpeedButton;
    SpinEditHeight: TSpinEdit;
    SpinFixedTabs: TSpinEdit;

    procedure JvTabBar1TabClosed(Sender: TObject; Item: TJvTabBarItem);
    procedure JvTabBar1TabCloseQuery(Sender: TObject; Item: TJvTabBarItem;
      var CanClose: Boolean);
   // procedure JvTabBar1TabMoved(Sender: TObject; Item: TJvTabBarItem);

    procedure actn_AddMultipleTabsExecute(Sender: TObject);
    procedure actn_AddOneTabExecute(Sender: TObject);
    procedure actn_CloseSelectedTabExecute(Sender: TObject);
    procedure actn_ExitExecute(Sender: TObject);
    procedure actn_HideTabExecute(Sender: TObject);
    procedure actn_AddParentTestExecute(Sender: TObject);
    procedure actn_DockInExecute(Sender: TObject);

    procedure cbCloseButtonChange(Sender: TObject);
    procedure cbAllowTabMovingChange(Sender: TObject);
    procedure cbTabHotTrackingChange(Sender: TObject);

    procedure cmbPainterChange(Sender: TObject);
    procedure cmbOrientationChange(Sender: TObject);

    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure SpinEditHeightChange(Sender: TObject);
    procedure SpinFixedTabsChange(Sender: TObject);
  private
    FiFixedTabs: integer;
    iMeinCounter:integer;

    procedure AddOneTab;
    procedure CloseSelectedTab;
    procedure AddMultipleTabs;
    procedure AddParentTest;
    procedure DockIn;

    procedure RenewMenuItems(mCon:TMenuItem);
  public
    property piFixedTabs:integer read FiFixedTabs write FiFixedTabs default 0;
    procedure MyMenuClick(Sender:TObject);
    // procedure CloseTabWithoutQuestion; //Tab schließen ohne Rückfrage, zb weil das Fenster ausgedockt wurde
  end;

var
  MainForm: TMainForm;

implementation

uses
  unit1 , udmJvTabBar
  ,unitMemo, unitimage,unitGrid,unitShell, uParentPage;

{$R *.lfm}

{ TMainForm }

procedure TMainForm.cbCloseButtonChange(Sender: TObject);
begin
  JvTabBar1.CloseButton := cbCloseButton.Checked;
end;

procedure TMainForm.actn_AddOneTabExecute(Sender: TObject);
begin
  AddOneTab;
end;

procedure TMainForm.actn_CloseSelectedTabExecute(Sender: TObject);
begin
  CloseSelectedTab;
end;

procedure TMainForm.actn_AddMultipleTabsExecute(Sender: TObject);
begin
  AddMultipleTabs;
end;

procedure TMainForm.cbTabHotTrackingChange(Sender: TObject);
begin
  JvTabBar1.HotTracking := cbTabHotTracking.Checked;
end;

procedure TMainForm.cbAllowTabMovingChange(Sender: TObject);
begin
  JvTabBar1.AllowTabMoving := cbAllowTabMoving.Checked;
end;

procedure TMainForm.cmbPainterChange(Sender: TObject);
begin
  case cmbPainter.ItemIndex of
    0: JvTabBar1.Painter := dmJvTabBar.JvTabBarPainterStandard;
    1: JvTabBar1.Painter := dmJvTabBar.JvModernTabBarPainter1;
    2: JvTabBar1.Painter := dmJvTabBar.JvTabBarXPPainter1;
  end;
end;

procedure TMainForm.JvTabBar1TabCloseQuery(Sender: TObject;
  Item: TJvTabBarItem; var CanClose: Boolean);
begin
  if JvTabBar1.SelectedTab.Index <= piFixedTabs -1 then begin
     ShowMessage('Der Tab ' + Item.Caption + ' ist fixiert und kann nicht geschlossen werden!');
     CanClose:=false;
  end
  else
   CanClose := MessageDlg('Do you really want to close tab ' + Item.Caption + '?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end;

procedure TMainForm.JvTabBar1TabClosed(Sender: TObject; Item: TJvTabBarItem);
begin
  RenewMenuItems(mnuTabs);
end;

procedure TMainForm.actn_DockInExecute(Sender: TObject);
begin
  DockIn;
end;

procedure TMainForm.actn_AddParentTestExecute(Sender: TObject);
begin
  AddParentTest;
end;

procedure TMainForm.actn_HideTabExecute(Sender: TObject);
begin
  JvTabBar1.SelectedTab.Visible:=false;
end;

procedure TMainForm.SpinEditHeightChange(Sender: TObject);
begin
  JvTabBar1.Height:= SpinEditHeight.Value;
  pnlTabsButtons.Height:=SpinEditHeight.Value;;
end;

procedure TMainForm.SpinFixedTabsChange(Sender: TObject);
begin
  piFixedTabs:= SpinFixedTabs.Value;
  RenewMenuItems(mnuTabs);
end;

//*****************************************

procedure TMainForm.AddOneTab;
var
  s:string;
  aForm: TForm1;
  i:integer;
  aTab:TJvTabBarItem;
begin
  inc(iMeinCounter);
  s:='Ein Tab '+inttostr(iMeinCounter);

  aTab:=JvTabBar1.AddTab(s);  //offensichtlich wird auch gleichzeitig eine jvStandardpage in der Pagelist angelegt und synchronisiert.
  aTab.ImageIndex:=1;
  JvTabBar1.SelectedTab:=aTab;

  { die Aufgabe ist es ein Formular in die richtige Seite der JvPagelist einzukleben.
    ob direkt mit parent oder auch über die Dockingfunktion ist erstmal egal

    Letztlich soll die Funktion so sein dass es eine TForm entweder gedockt/eingeklebt oder "frei fliegend" sein kann.
  }

  aForm:=TForm1.Create(self);
  aForm.Parent := TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];  // <=== hier kracht es
  aForm.BorderStyle:=bsNone;
  aForm.Align:=alclient;
  aForm.Label1.Caption:='Form 1 -- Nummer '+inttostr(iMeinCounter);
  aForm.Show;

  RenewMenuItems(mnuTabs);
end;

procedure TMainForm.CloseSelectedTab;
begin
  JvTabBar1.CloseTab(JvTabBar1.SelectedTab);
  //RenewMenuItems(mnuTabs);    //Done in OnTabClosed
end;

procedure TMainForm.AddMultipleTabs;
begin
  with jvTabBar1.AddTab('Memo') do begin
    ImageIndex:=0;
  end;
  with TFormMemo.Create(self) do begin
    Parent := TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];
    BorderStyle:=bsNone;
    Align:=alclient;
    Show;
  end;
  inc(iMeinCounter);

  with jvTabBar1.AddTab('Image') do begin
    ImageIndex:=1;
  end;
  with TFormImage.Create(self) do begin
    Parent := TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];
    BorderStyle:=bsNone;
    Align:=alclient;
    Show;
  end;
  inc(iMeinCounter);

  with jvTabBar1.AddTab('Grid') do begin
    ImageIndex:=2;
  end;
  with TFormGrid.Create(self) do begin
    Parent := TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];
    BorderStyle:=bsNone;
    Align:=alclient;
    Show;
  end;
  inc(iMeinCounter);

  with jvTabBar1.AddTab('Shell Controls') do begin
    ImageIndex:=3;
  end;
  with TFormShell.Create(self) do begin
    Parent := TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];
    BorderStyle:=bsNone;
    Align:=alclient;
    Show;
  end;
  inc(iMeinCounter);

  RenewMenuItems(mnuTabs);
end;


{hier wird der Tab erzeugt und eine neue Form quasi "von außen" erzeugt und eingehängt.
}
procedure TMainForm.AddParentTest;
var
  s:string;
  aForm: TFormParentPage;
  i:integer;
  aTab:TJvTabBarItem;
begin
  inc(iMeinCounter);
  s:='Ein Tab '+inttostr(iMeinCounter);

  aTab:=JvTabBar1.AddTab(s);  //offensichtlich wird auch gleichzeitig eine jvStandardpage in der Pagelist angelegt und synchronisiert.
  aTab.ImageIndex:=1;
  JvTabBar1.SelectedTab:=aTab;

  { die Aufgabe ist es ein Formular in die richtige Seite der JvPagelist einzukleben.
    ob direkt mit parent oder auch über die Dockingfunktion ist erstmal egal

    Letztlich soll die Funktion so sein dass es eine TForm entweder gedockt/eingeklebt oder "frei fliegend" sein kann.
  }

  aForm:=TFormParentPage.Create(self);
  aForm.Parent := TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];  // <=== hier kracht es
  aForm.BorderStyle:=bsNone;
  aForm.Align:=alclient;
  aForm.poTabBar:=JvTabBar1;
  aForm.Label1.Caption:='Form 1 -- Nummer '+inttostr(iMeinCounter);
  aForm.Show;

  RenewMenuItems(mnuTabs);

end;


{hier wird Die Form erzeugt und Mitgeteilt was ihre Bezugspunkte sind
Das eigentliche erzeugen und Einhängen übernimmt dann schon die Form
}
procedure TMainForm.DockIn;
var
  s:string;
  aForm: TFormParentPage;
begin
  aForm:=TFormParentPage.Create(self);
  aForm.poTabBar:=JvTabBar1;
  aForm.poPageList:=JvPageList1;
  //aForm.psCaption:='das sollte der Nachfahre der Form wissen';
  aForm.Einklinken;
end;

procedure TMainForm.RenewMenuItems(mCon: TMenuItem);
var
  slSections:TStringlist;
  i:integer;
  MyItem:TMenuItem;
  sSection:string;
begin
  For i:= mCon.Count-1 downto 0 do
  mCon.Delete(i);
  mCon.Enabled:=false;   //disable for it has no no items

  for i:=0 to jvtabbar1.Tabs.Count  -1 do
  begin
    MyItem:=TMenuItem.Create(mCon);
    MyItem.Caption := jvtabbar1.Tabs[i].Caption;

    if i <= piFixedTabs -1 then
       MyItem.Enabled := false;
    MyItem.Tag := jvtabbar1.Tabs[i].ImageIndex;
    MyItem.ImageIndex := jvtabbar1.Tabs[i].ImageIndex;
    MyItem.OnClick:= @MyMenuClick;
    mCon.Add(MyItem);
  end;

  if mCon.Count >0 then mCon.Enabled:=true; //enable if it has Items

end;

procedure TMainForm.MyMenuClick(Sender: TObject);
begin
  //showmessage('clicked : ' + TMenuItem(Sender).Caption); //just for debugging
  jvtabbar1.SelectedTab:=jvtabbar1.Tabs[TMenuItem(Sender).Tag];
end;



procedure TMainForm.cmbOrientationChange(Sender: TObject);
begin
  case cmbOrientation.ItemIndex of
    0: begin
         JvTabBar1.Orientation := toTop;
         JvTabBar1.Align := alTop;
       end;
    1: begin
         JvTabBar1.Orientation := toBottom;
         JvTabBar1.Align := alBottom;
       end;
  end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  SpinFixedTabsChange(nil);
  AddMultipleTabs;
end;

procedure TMainForm.FormCreate(Sender: TObject);
//var
  //Speedbutton:TSpeedbutton;

begin
  If not assigned(dmJvTabBar) then dmJvTabBar:=TdmJvTabBar.Create(self);
  JvTabBar1.Images := dmJvTabBar.ImageList1;
  JvTabBar1.Painter := dmJvTabBar.JvTabBarPainterStandard;
  JvTabBar1.Height:=SpinEditHeight.Value;

  //Speedbutton:=TSpeedbutton.Create(JvTabBar1);
  //Speedbutton.Parent:=JvTabBar1;
  //SpeedButton.Images:=dmJvTabBar.ImageList1;
  //SpeedButton.ImageIndex:=1;
  //SpeedButton.Anchors:=[akRight,akBottom];
  //Speedbutton.Show;

  //SpeedButton1.Images:=dmJvTabBar.ImageList1;
  //SpeedButton1.ImageIndex:=1;
  //

  MainMenu1.Images := dmJvTabBar.ImageList1;
  iMeinCounter:=0;

end;



procedure TMainForm.actn_ExitExecute(Sender: TObject);
begin
  Application.Terminate;
end;

end.

