unit uParentPage;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,JvTabBar,JvPageList;

type

  { TFormParentPage }

  TFormParentPage = class(TForm)
    bttnFreeForm: TButton;
    bttnDockForm: TButton;
    bttnCloseTab: TButton;
    Label1: TLabel;
    procedure bttnCloseTabClick(Sender: TObject);
    procedure bttnDockFormClick(Sender: TObject);
    procedure bttnFreeFormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FbIsUniqueWindow: boolean;
    FbShallRefresh: boolean;
    FiFormtype: integer;
    FiID: integer;
     FImageIndex: integer;
     FsCaption: String;
     FTabBar:TJvTabBar;
     FPageList:TJvPageList;  //TJvStandardPage
     procedure SetbIsUniqueWindow(AValue: boolean);
     procedure SetbShallRefresh(AValue: boolean);
     procedure SetiFormtype(AValue: integer);
     procedure SetiID(AValue: integer);
     procedure SetImageIndex(AValue: integer);
     procedure SetPageList(AValue: TJvPageList);
     procedure SetsCaption(AValue: String);
     procedure SetTabBar(AValue: TJvTabBar);
  public
     //die ID bzw der Primärschlüssel der zu der jeweiligen Form gehört
     property piID: integer read FiID write SetiID default -1;
     //die Formtype mit constants aus uconst
     property piFormtype: integer read FiFormtype write SetiFormtype default -1;

     //Soll das Formular vor dem weiterbearbeiten refresht werden? Die Daten wurden möglicherweise von einem anderen Formular in der DB geändert
     //das passiert bei Linkänderungen oder anderen Änderungen die mit einer Person verbiundens ein können.
     property pbShallRefresh:boolean read FbShallRefresh write SetbShallRefresh default false;

     {ein Fenster ist mit piID und piFormType eeindeutig definiert. Fenster können einzigartig, also nur einmal oder mehrmals mit gleicherIF/Typ geöffnet werden
     wenn ein Fenster unique geöffnet werden soll, muss die Prozedur, die es öffnet sie Pagelist durhsuchen um festzustellen ob dieses Fenster schon geöffnet ist.
     ist es schon geöffnet, wird es selektiert, andernfalls neu erzeugt}
     property pbIsUniqueWindow:boolean read FbIsUniqueWindow write SetbIsUniqueWindow default false;

     //macht vielleicht keinen sinn denn eine abfrage auf parent=nil würde das gleiche liefern
//     property pbIsDockedInTab:boolean read FbIsDockedInTab write SetbIsDockedInTab default false;

     property poTabBar:TJvTabBar read FTabBar write SetTabBar;
     property poPageList:TJvPageList read FPageList write SetPageList;
     property piImageIndex:integer read FImageIndex write SetImageIndex default 0;
     property psCaption:String read FsCaption write SetsCaption;
     procedure Einklinken;
     procedure Ausklinken;
     procedure CloseTab;
  end;

var
  FormParentPage: TFormParentPage;

implementation

{$R *.lfm}

{ TFormParentPage }

procedure TFormParentPage.SetTabBar(AValue: TJvTabBar);
begin
  if FTabBar=AValue then Exit;
  FTabBar:=AValue;
end;

procedure TFormParentPage.Einklinken;
var
  s:string;
  aForm: TFormParentPage;
  aTab:TJvTabBarItem;
  iPageNumber:integer;
begin
  //nc(iMeinCounter);
  //s:='Ein Tab '+inttostr(iMeinCounter);

  if assigned(aForm) then begin

    aTab:=FTabBar.AddTab(s);  //offensichtlich wird auch gleichzeitig eine jvStandardpage in der Pagelist angelegt und synchronisiert.
    aTab.ImageIndex:=FImageIndex;
    FTabBar.SelectedTab:=aTab;

    { die Aufgabe ist es ein Formular in die richtige Seite der JvPagelist einzukleben.
      ob direkt mit parent oder auch über die Dockingfunktion ist erstmal egal

      Letztlich soll die Funktion so sein dass es eine TForm entweder gedockt/eingeklebt oder "frei fliegend" sein kann.
    }


    //aForm.Parent := TJvPageList(FTabBar.PageList).Pages[FTabBar.PageList.PageCount-1];

    //  aForm.Parent := TJvPageList(FPageList).Pages[TJvPageList(FPageList).PageCount-1];
    //                     TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];

    //TJvPageList(JvTabBar.PageList).Pages[JvTabBar.Tabs.Count-1];



    iPageNumber:=FTabBar.Tabs.Count-1;


    aForm.Parent:=TJvPageList(FTabBar.PageList).Pages[iPageNumber];
    aForm.BorderStyle:=bsNone;
    aForm.Align:=alclient;

    aForm.Label1.Caption:=FsCaption;
    aForm.Show;

 end
 else
  showmessage('aForm unassigned');

end;

procedure TFormParentPage.Ausklinken;
begin
  Self.parent:=nil;
  Self.Align:=alNone;
  Self.BorderStyle:=bsSizeable;
  Self.Position:=poMainFormCenter;
  FTabBar.CloseTab(FTabBar.SelectedTab);
end;

procedure TFormParentPage.CloseTab;
begin
  FTabBar.CloseTab(FTabBar.SelectedTab);
end;



procedure TFormParentPage.FormCreate(Sender: TObject);
begin
  FImageIndex:=0;
  FsCaption:='unknown Caption';
end;

//********* Button Events
procedure TFormParentPage.bttnFreeFormClick(Sender: TObject);
begin
  Ausklinken;
end;

procedure TFormParentPage.bttnDockFormClick(Sender: TObject);
begin
  Einklinken;
end;

procedure TFormParentPage.bttnCloseTabClick(Sender: TObject);
begin
  CloseTab;
end;

//********* Setter

procedure TFormParentPage.SetImageIndex(AValue: integer);
begin
  if FImageIndex=AValue then Exit;
  FImageIndex:=AValue;
end;

procedure TFormParentPage.SetPageList(AValue: TJvPageList);
begin
  if FPageList=AValue then Exit;
  FPageList:=AValue;
end;

procedure TFormParentPage.SetbShallRefresh(AValue: boolean);
begin
  if FbShallRefresh=AValue then Exit;
  FbShallRefresh:=AValue;
end;

procedure TFormParentPage.SetbIsUniqueWindow(AValue: boolean);
begin
  if FbIsUniqueWindow=AValue then Exit;
  FbIsUniqueWindow:=AValue;
end;

procedure TFormParentPage.SetiFormtype(AValue: integer);
begin
  if FiFormtype=AValue then Exit;
  FiFormtype:=AValue;
end;

procedure TFormParentPage.SetiID(AValue: integer);
begin
  if FiID=AValue then Exit;
  FiID:=AValue;
end;

procedure TFormParentPage.SetsCaption(AValue: String);
begin
  if FsCaption=AValue then Exit;
  FsCaption:=AValue;
end;

end.

